/* *** CfgPool.h *** Configuration Pool

              Copyright (C) 2002 Ral Nez de Arenas Coronado

        This program is free software; you can redistribute it and/or
         modify it under the terms of the GNU General Public License
                as published by the Free Software Foundation;
                      either version 2 of the License,
                   or (at your option) any later version.

       This program is distributed in the hope that it will be useful,
         but WITHOUT ANY WARRANTY; without even the implied warranty
           of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
            See the GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
             (`GPL') along with this program; if not, write to:

                       Free Software Foundation, Inc.
                         59 Temple Place, Suite 330
                         Boston, MA 02111-1307  USA

                     Report bugs to <raul@pleyades.net>
*/
#ifndef __X_CFGPOOL_X__
#define __X_CFGPOOL_X__

#include <stdint.h>
#include <limits.h>
#include <inttypes.h>

#if SSIZE_MAX > SIZE_MAX
#error Cannot build, since SSIZE_MAX appears to be greater than SIZE_MAX!!!
#endif

typedef struct CfgPool *CfgPool;

CfgPool cfgpool_create (const char *);
CfgPool cfgpool_delete (CfgPool);

char *    cfgpool_getstring  (CfgPool, const char *);
uintmax_t cfgpool_getnatural (CfgPool, const char *, unsigned int);
intmax_t  cfgpool_getinteger (CfgPool, const char *, unsigned int);

#endif
