/* *** chain.h *** The indescribable Chain container

Copyright (C) 2002,03 Ral Nez de Arenas Coronado

        This program is free software; you can redistribute it and/or
         modify it under the terms of the GNU General Public License
           version 2 as published by the Free Software Foundation.

       This program is distributed in the hope that it will be useful,
         but WITHOUT ANY WARRANTY; without even the implied warranty
           of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
            See the GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
             (`GPL') along with this program; if not, write to:

                       Free Software Foundation, Inc.
                         59 Temple Place, Suite 330
                         Boston, MA 02111-1307  USA
*/
#ifndef __X_CHAIN_X__
#define __X_CHAIN_X__
#include <stdlib.h>

/*
The forward definitions are needed to declare objects without knowing
its internals, so the user is not tempted to access them directly ;)
BTW, this make objects non-dereferenciable...
*/

typedef struct Chain *Chain;

Chain chain_create (void);
Chain chain_delete (Chain);

size_t chain_size   (Chain);
size_t chain_offset (Chain);

void *chain_put  (Chain, void *);
void *chain_get  (Chain);
void *chain_del  (Chain);

void *chain_next (Chain);
void *chain_prev (Chain);
void  chain_home (Chain);

void *chain_seek (Chain, size_t);
#endif
