/*
    Filename: palabel.h
    Synopsis: PA Clickable Label with 3D effect headers.

                           Copyright (C) 2000,2001
            Ral Nez de Arenas Coronado <raul@pleyades.net>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to:

        Free Software Foundation, Inc.
        59 Temple Place, Suite 330
        Boston, MA 02111-1307 USA

*/

#ifndef __PALABEL_H__
#define __PALABEL_H__

#include <string.h>
#include <stdlib.h>
#include "x.h"
#include "mobs.h"

struct sPALabel;

typedef struct sPALabel *PALabel; 

void palabel_init (void);
void palabel_done (void);
PALabel palabel_create(unsigned int, callback, void *);
void    palabel_destroy (PALabel);

void palabel_map   (PALabel, unsigned int);
void palabel_unmap (PALabel);

void palabel_move(PALabel, int, int);
void palabel_reparent (PALabel, Window, int, int);
void palabel_settext (PALabel, const char *, size_t);
void palabel_setfocus (PALabel);
void palabel_unsetfocus (PALabel);
unsigned int palabel_height (void);
unsigned int palabel_width (PALabel);

#endif  
