/*
    Filename: pawindow.h
    Synopsis: PA Window headers.
    
                          Copyright (C) 2000, 2001
            Ral Nez de Arenas Coronado <raul@pleyades.net>
	         David Gmez Espinosa <david@pleyades.net>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to:

        Free Software Foundation, Inc.
        59 Temple Place, Suite 330
        Boston, MA 02111-1307 USA

*/

#ifndef __PAWINDOW_H__
#define __PAWINDOW_H__

#include <limits.h>
#include <stdlib.h>

#include "x.h"
#include "mobs.h"
#include "palabel.h"

#define BUTTONSZ 20
#define BUTTONS_W (BUTTONSZ*3)

struct _atoms atoms;

struct sPAWindow;

typedef struct sPAWindow *PAWindow;

extern PAWindow focuspawindow;

/* Constructors and destructors */
void     pawindow_init    (void);
void     pawindow_done    (void);
PAWindow pawindow_create  (Window);
void     pawindow_destroy (PAWindow);

/* Map handling funcs */
void pawindow_map   (PAWindow);
void pawindow_unmap (PAWindow);

/* Geometry management */
void pawindow_resize (PAWindow, unsigned int, unsigned int);
void pawindow_move   (PAWindow, int, int);
void pawindow_shade  (PAWindow);
void pawindow_unshade  (PAWindow);

/* Accesors */
PALabel pawindow_icon (PAWindow);
int pawindow_getwindowx (PAWindow);
int pawindow_getwindowy (PAWindow);

/* Callbacks */
void kill_client (void *);
void iconify_client (void *);
void maximize_client (void *);
void rotate_clients (void *);
#endif
